package com.hai.dao;

import com.hai.entity.HighCouponCodeOther;
import com.hai.entity.HighCouponCodeOtherExample.Criteria;
import com.hai.entity.HighCouponCodeOtherExample.Criterion;
import com.hai.entity.HighCouponCodeOtherExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighCouponCodeOtherSqlProvider {

    public String countByExample(HighCouponCodeOtherExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_coupon_code_other");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighCouponCodeOtherExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_coupon_code_other");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighCouponCodeOther record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_coupon_code_other");
        
        if (record.getType() != null) {
            sql.VALUES("`type`", "#{type,jdbcType=INTEGER}");
        }
        
        if (record.getCouponAgentCodeId() != null) {
            sql.VALUES("coupon_agent_code_id", "#{couponAgentCodeId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderId() != null) {
            sql.VALUES("order_id", "#{orderId,jdbcType=BIGINT}");
        }
        
        if (record.getChildOrderId() != null) {
            sql.VALUES("child_order_id", "#{childOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getCouTypeCode() != null) {
            sql.VALUES("cou_type_code", "#{couTypeCode,jdbcType=VARCHAR}");
        }
        
        if (record.getCouNo() != null) {
            sql.VALUES("cou_no", "#{couNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getActiveTime() != null) {
            sql.VALUES("active_time", "#{activeTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getValidStartDate() != null) {
            sql.VALUES("valid_start_date", "#{validStartDate,jdbcType=TIMESTAMP}");
        }
        
        if (record.getValidEndDate() != null) {
            sql.VALUES("valid_end_date", "#{validEndDate,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighCouponCodeOtherExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("`type`");
        sql.SELECT("coupon_agent_code_id");
        sql.SELECT("order_id");
        sql.SELECT("child_order_id");
        sql.SELECT("cou_type_code");
        sql.SELECT("cou_no");
        sql.SELECT("`status`");
        sql.SELECT("active_time");
        sql.SELECT("valid_start_date");
        sql.SELECT("valid_end_date");
        sql.SELECT("create_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_coupon_code_other");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighCouponCodeOther record = (HighCouponCodeOther) parameter.get("record");
        HighCouponCodeOtherExample example = (HighCouponCodeOtherExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_coupon_code_other");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        }
        
        if (record.getCouponAgentCodeId() != null) {
            sql.SET("coupon_agent_code_id = #{record.couponAgentCodeId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderId() != null) {
            sql.SET("order_id = #{record.orderId,jdbcType=BIGINT}");
        }
        
        if (record.getChildOrderId() != null) {
            sql.SET("child_order_id = #{record.childOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getCouTypeCode() != null) {
            sql.SET("cou_type_code = #{record.couTypeCode,jdbcType=VARCHAR}");
        }
        
        if (record.getCouNo() != null) {
            sql.SET("cou_no = #{record.couNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getActiveTime() != null) {
            sql.SET("active_time = #{record.activeTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getValidStartDate() != null) {
            sql.SET("valid_start_date = #{record.validStartDate,jdbcType=TIMESTAMP}");
        }
        
        if (record.getValidEndDate() != null) {
            sql.SET("valid_end_date = #{record.validEndDate,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_coupon_code_other");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        sql.SET("coupon_agent_code_id = #{record.couponAgentCodeId,jdbcType=BIGINT}");
        sql.SET("order_id = #{record.orderId,jdbcType=BIGINT}");
        sql.SET("child_order_id = #{record.childOrderId,jdbcType=BIGINT}");
        sql.SET("cou_type_code = #{record.couTypeCode,jdbcType=VARCHAR}");
        sql.SET("cou_no = #{record.couNo,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("active_time = #{record.activeTime,jdbcType=TIMESTAMP}");
        sql.SET("valid_start_date = #{record.validStartDate,jdbcType=TIMESTAMP}");
        sql.SET("valid_end_date = #{record.validEndDate,jdbcType=TIMESTAMP}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighCouponCodeOtherExample example = (HighCouponCodeOtherExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighCouponCodeOther record) {
        SQL sql = new SQL();
        sql.UPDATE("high_coupon_code_other");
        
        if (record.getType() != null) {
            sql.SET("`type` = #{type,jdbcType=INTEGER}");
        }
        
        if (record.getCouponAgentCodeId() != null) {
            sql.SET("coupon_agent_code_id = #{couponAgentCodeId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderId() != null) {
            sql.SET("order_id = #{orderId,jdbcType=BIGINT}");
        }
        
        if (record.getChildOrderId() != null) {
            sql.SET("child_order_id = #{childOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getCouTypeCode() != null) {
            sql.SET("cou_type_code = #{couTypeCode,jdbcType=VARCHAR}");
        }
        
        if (record.getCouNo() != null) {
            sql.SET("cou_no = #{couNo,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getActiveTime() != null) {
            sql.SET("active_time = #{activeTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getValidStartDate() != null) {
            sql.SET("valid_start_date = #{validStartDate,jdbcType=TIMESTAMP}");
        }
        
        if (record.getValidEndDate() != null) {
            sql.SET("valid_end_date = #{validEndDate,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighCouponCodeOtherExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}